-- Desc:	ShareNode
-- Author:	lihanfeng
-- Date:	2015-03-10

local SHARE_SELECT_DIV = 150

local share_node_layout =
{		name="share_node",type=0,typeName="View",time=32669922,x=0,y=0,width=339,height=70,visible=1,
		{
			name="tag",type=4,typeName="Text",time=33016394,x=0,y=0,width=339,height=40,visible=1,fontSize=30,align=kAlignLeft,colorRed=110,colorGreen=210,colorBlue=255,string=[[请选择炫耀地点：]],
		},
}

local share_node_item_layout =
{
	name="btn_node",type=0,typeName="View",time=32669922,x=0,y=40,width=138,height=68,visible=1,
	{
		name="btn_bg",type=1,typeName="Button",time=32669038,x=0,y=0,width=138,height=68,visible=1,file="sns_share/blue.png",
	},
	{
		name="selected_label",type=1,typeName="Image",time=32669038,x=0,y=0,width=138,height=68,visible=1,file="sns_share/green.png",
	},
	{
		name="btn",type=2,typeName="Image",time=32669931,x=0,y=-2,width=40,height=40,visible=1,file="sns_share/wx_enabled.png",nodeAlign = kAlignCenter,
	},
}

local ShareDialog = {}
ShareDialog.SHARE_MEANS_INFO_QQ = {
	enabled_file = "sns_share/qq_enabled.png",
	disabled_file = "sns_share/qq_disabled.png",
	callback = function (obj)
		if not GameCache.getQQClientAvailable() then
			NoticeUtil.startAlarmNotice("分享失败，未安装QQ应用！");
			return ;
		end

		Flurry.Event(Flurry.kSHARE_DIALOG_QQ);

		local title = "博雅鬥地主";
		local summary = obj.m_editText:getText();
		local targetUrl = "http://myddz.boyaa.com/";
		local imgLocalUrl = obj.m_sharePicFilePath;

		NativeEvent.shareToQQ(title, summary, targetUrl, imgLocalUrl, obj.onShareResult, obj);
	end
}

ShareDialog.SHARE_MEANS_INFO_QZONE = {
	enabled_file = "sns_share/qzone_enabled.png",
	disabled_file = "sns_share/qzone_disabled.png",
	callback = function (obj)
		if not GameCache.getQQClientAvailable() then
			NoticeUtil.startAlarmNotice("分享失败，未安装QQ应用！");
			return ;
		end

		Flurry.Event(Flurry.kSHARE_DIALOG_QZONE);

		local title = obj.m_editText:getText();
		local summary = "";
		local targetUrl = "http://myddz.boyaa.com/";
		local imgLocalUrl = obj.m_sharePicFilePath;

		NativeEvent.shareToQzone(title, summary, targetUrl, imgLocalUrl, obj.onShareResult, obj);
	end
}

ShareDialog.SHARE_MEANS_INFO_WX = {
	enabled_file = "sns_share/wx_enabled.png",
	disabled_file = "sns_share/wx_disabled.png",
	callback = function (obj)
		if not GameCache.getWxAvailable() then
			NoticeUtil.startAlarmNotice("分享失败，未安装微信应用！");
			return ;
		end

		Flurry.Event(Flurry.kSHARE_DIALOG_WEIXIN);

		-- 微信分享只分享网页
		local appid = string_get("wx_app_id");
		local shareType = 3;
		local text = obj.m_editText:getText();
		-- local imgPath = obj.m_sharePicFilePath; --走新版的分享URL
		local imgPath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/image_b.png";
		local webpageUrl = "http://ddz.boyaagame.com/";
		--https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/image_a.png?v=1  --微信好友分享 图片地址
		--Log.d("ShareDialog.SHARE_MEANS_INFO_WX__js__appid:", appid .. "-- text:" .. text .. "--imgPath:" .. imgPath )
		NativeEvent.shareToWeixin(appid, shareType, "博雅鬥地主" ,text, imgPath, webpageUrl, false, obj.onShareResult, obj);
	end
}

ShareDialog.SHARE_MEANS_INFO_WXTIMELINE = {
	enabled_file = "sns_share/wx_timeline_enabled.png",
	disabled_file = "sns_share/wx_timeline_disabled.png",
	callback = function (obj)
		if not GameCache.getWxAvailable() then
			NoticeUtil.startAlarmNotice("分享失败，未安装微信应用！");
			return ;
		end

		Flurry.Event(Flurry.kSHARE_DIALOG_WX_TIMELINE);

		local appid = string_get("wx_app_id");
		local shareType = 3;
		local text = obj.m_editText:getText();
		-- local imgPath = obj.m_sharePicFilePath;--走新版的分享URL
		local imgPath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/image_b.png";
		local webpageUrl = "http://ddz.boyaagame.com/";
		--Log.d("ShareDialog.SHARE_MEANS_INFO_WXTIMELINE__js__appid:", appid .. "-- text:" .. text .. "--imgPath:" .. imgPath )
		NativeEvent.shareToWeixin(appid, shareType,text, "博雅鬥地主", imgPath, webpageUrl, true, obj.onShareResult, obj);
	end
}

ShareDialog.SHARE_MEANS_INFO_FACEBOOK = {
	enabled_file = "sns_share/facebook_enabled.png";
	disabled_file = "sns_share/facebook_disabled.png";

	callback = function (obj)
		Flurry.Event(Flurry.kSHARE_DIALOG_FACEBOOK);

        local title = "博雅鬥地主";
		local text = obj.m_editText:getText();
		local webUrl = "http://ddz.boyaagame.com/";
		-- local imgPath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/gr_share_1.png"  	--原分享图地址
		local imgPath = "https://fbpoker.boyaagame.com/mobile/fb/landlordpc/images/gr_share_2.png?v=2"	--6.9版更改的图片
		NativeEvent.shareToFB(0, title, text, imgPath, webUrl, obj.onShareResult, obj);
	end
}

ShareNode = class(Node);

function ShareNode:ctor()
	self.m_defaultShareMeansIndex = 1
	self.t_visibleShare = {}
	self.t_selectLab = {}

	Flurry.Event(Flurry.kSHARE_MATCH_CHUXIAN);

	self:initVisibleShareTalbe()
	self:initView()
end

function ShareNode:dtor()

end

function ShareNode:initView()
	local view = new(SceneEx, share_node_layout):getRoot();
	self:setSize(view:getSize())
	self:addChild(view)

	--根据self.t_visibleShare初始化分享节点
	local shareLayout = self:getChildByName2("share_node")
	for k,v in ipairs(self.t_visibleShare) do
		local btnView = new(SceneEx,share_node_item_layout):getRoot()
		btnView:setPos((k-1)*SHARE_SELECT_DIV,btnView.m_y) --由于没有只设置X坐标的方法，所以访问了内部的属性m_y
		shareLayout:addChild(btnView)

		local func = {} --使用闭包简化逻辑
		func.callback =
			function()
				if(k == self.m_defaultShareMeansIndex) then return end

				self.m_defaultShareMeansIndex = k
				self:updateSelectLab()
			end

		local btn = btnView:getChildByName2("btn")
		btn:setFile(v.enabled_file)

		btnView:getChildByName2("btn_bg"):setOnClick(func,func.callback)

		--隐藏选择标签
		self.t_selectLab[k] = btnView:getChildByName2("selected_label")
		self.t_selectLab[k]:setVisible(false)
	end

	self.t_selectLab[self.m_defaultShareMeansIndex]:setVisible(true)
end

function ShareNode:updateSelectLab()
	for k,v in ipairs(self.t_selectLab) do
		if(k == self.m_defaultShareMeansIndex) then
			self.t_selectLab[k]:setVisible(true)
		else
			self.t_selectLab[k]:setVisible(false)
		end
	end
end

--根据微信和QQ可用状态来初始化可见的分享列表
function ShareNode:initVisibleShareTalbe()
    --[[
	--如果玩家安装了微信（不管是否安装QQ）则显示：分享到微信朋友圈，分享给微信好友，分享给QQ好友
	if GameCache.getWxAvailable() then
		self.t_visibleShare = {
			ShareDialog.SHARE_MEANS_INFO_WXTIMELINE,
			ShareDialog.SHARE_MEANS_INFO_WX,
			ShareDialog.SHARE_MEANS_INFO_QQ,
			ShareDialog.SHARE_MEANS_INFO_FACEBOOK,
		}
	--如果玩家没有安装微信，安装了QQ，则显示：分享到QQ空间，分享给QQ好友
	elseif GameCache.getQQClientAvailable() then
		self.t_visibleShare = {
			ShareDialog.SHARE_MEANS_INFO_QZONE,
			ShareDialog.SHARE_MEANS_INFO_QQ,
		}
	--如果玩家既没安装微信，也没安装QQ，则显示：分享到微信朋友圈，分享给微信好友，点击任意分享图标：分享失败，未安装微信应用！
	else
		self.t_visibleShare = {
			ShareDialog.SHARE_MEANS_INFO_WXTIMELINE,
			ShareDialog.SHARE_MEANS_INFO_WX,
		}
	end]]
    self.t_visibleShare = {
    	ShareDialog.SHARE_MEANS_INFO_WX,
    	ShareDialog.SHARE_MEANS_INFO_WXTIMELINE,
    	ShareDialog.SHARE_MEANS_INFO_FACEBOOK,
    };
end

function ShareNode:getShareFunction()
	return self.t_visibleShare[self.m_defaultShareMeansIndex].callback
end